Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -1852,132 +1836,132 @@
   END DO
 
-!CR fix computation of inb
-!keep flag or modify in all cases?
+  !CR fix computation of inb
+  !keep flag or modify in all cases?
   IF (iflag_mix_adiab==1) THEN
+    DO i = 1, ncum
+      cape(i) = 0.
+      inb(i) = icb(i) + 1
+    ENDDO
+
+    DO k = 2, nl
+      DO i = 1, ncum
+        IF ((k>=iposit(i))) THEN
+          deltap = min(plcl(i), ph(i, k - 1)) - min(plcl(i), ph(i, k))
+          cape(i) = cape(i) + rrd * buoy(i, k - 1) * deltap / p(i, k - 1)
+          IF (cape(i)>0.) THEN
+            inb(i) = max(inb(i), k)
+          END IF
+        ENDIF
+      ENDDO
+    ENDDO
+
+    !  DO i = 1, ncum
+    !     PRINT*,"inb",inb(i)
+    !  ENDDO
+
+  ENDIF
+
+  ! -- end convect3
+
+  ! ori      do 510 i=1,ncum
+  ! ori        cape(i)=0.0
+  ! ori        capem(i)=0.0
+  ! ori        inb(i)=icb(i)+1
+  ! ori        inb1(i)=inb(i)
+  ! ori 510  continue
+
+  ! Originial Code
+
+  !    do 530 k=minorig+1,nl-1
+  !     do 520 i=1,ncum
+  !      IF(k.ge.(icb(i)+1))THEN
+  !       by=(tvp(i,k)-tv(i,k))*dph(i,k)/p(i,k)
+  !       byp=(tvp(i,k+1)-tv(i,k+1))*dph(i,k+1)/p(i,k+1)
+  !       cape(i)=cape(i)+by
+  !       IF(by.ge.0.0)inb1(i)=k+1
+  !       IF(cape(i).gt.0.0)THEN
+  !        inb(i)=k+1
+  !        capem(i)=cape(i)
+  !       endif
+  !      endif
+  !520    continue
+  !530  continue
+  !    do 540 i=1,ncum
+  !     byp=(tvp(i,nl)-tv(i,nl))*dph(i,nl)/p(i,nl)
+  !     cape(i)=capem(i)+byp
+  !     defrac=capem(i)-cape(i)
+  !     defrac=max(defrac,0.001)
+  !     frac(i)=-cape(i)/defrac
+  !     frac(i)=min(frac(i),1.0)
+  !     frac(i)=max(frac(i),0.0)
+  !540   continue
+
+  !    K Emanuel fix
+
+  !    CALL zilch(byp,ncum)
+  !    do 530 k=minorig+1,nl-1
+  !     do 520 i=1,ncum
+  !      IF(k.ge.(icb(i)+1))THEN
+  !       by=(tvp(i,k)-tv(i,k))*dph(i,k)/p(i,k)
+  !       cape(i)=cape(i)+by
+  !       IF(by.ge.0.0)inb1(i)=k+1
+  !       IF(cape(i).gt.0.0)THEN
+  !        inb(i)=k+1
+  !        capem(i)=cape(i)
+  !        byp(i)=(tvp(i,k+1)-tv(i,k+1))*dph(i,k+1)/p(i,k+1)
+  !       endif
+  !      endif
+  !520    continue
+  !530  continue
+  !    do 540 i=1,ncum
+  !     inb(i)=max(inb(i),inb1(i))
+  !     cape(i)=capem(i)+byp(i)
+  !     defrac=capem(i)-cape(i)
+  !     defrac=max(defrac,0.001)
+  !     frac(i)=-cape(i)/defrac
+  !     frac(i)=min(frac(i),1.0)
+  !     frac(i)=max(frac(i),0.0)
+  !540   continue
+
+  ! J Teixeira fix
+
+  ! ori      CALL zilch(byp,ncum)
+  ! ori      do 515 i=1,ncum
+  ! ori        lcape(i)=.TRUE.
+  ! ori 515  continue
+  ! ori      do 530 k=minorig+1,nl-1
+  ! ori        do 520 i=1,ncum
+  ! ori          IF(cape(i).lt.0.0)lcape(i)=.FALSE.
+  ! ori          if((k.ge.(icb(i)+1)).AND.lcape(i))THEN
+  ! ori            by=(tvp(i,k)-tv(i,k))*dph(i,k)/p(i,k)
+  ! ori            byp(i)=(tvp(i,k+1)-tv(i,k+1))*dph(i,k+1)/p(i,k+1)
+  ! ori            cape(i)=cape(i)+by
+  ! ori            IF(by.ge.0.0)inb1(i)=k+1
+  ! ori            IF(cape(i).gt.0.0)THEN
+  ! ori              inb(i)=k+1
+  ! ori              capem(i)=cape(i)
+  ! ori            endif
+  ! ori          endif
+  ! ori 520    continue
+  ! ori 530  continue
+  ! ori      do 540 i=1,ncum
+  ! ori          cape(i)=capem(i)+byp(i)
+  ! ori          defrac=capem(i)-cape(i)
+  ! ori          defrac=max(defrac,0.001)
+  ! ori          frac(i)=-cape(i)/defrac
+  ! ori          frac(i)=min(frac(i),1.0)
+  ! ori          frac(i)=max(frac(i),0.0)
+  ! ori 540  continue
+
+  ! --------------------------------------------------------------------
+  !   Prevent convection when top is too hot
+  ! --------------------------------------------------------------------
   DO i = 1, ncum
-     cape(i)=0.
-     inb(i)=icb(i)+1
+    IF (t(i, inb(i)) > T_top_max) iflag(i) = 10
   ENDDO
-  
-  DO k = 2, nl 
-    DO i = 1, ncum
-       IF ((k>=iposit(i))) THEN
-       deltap = min(plcl(i), ph(i,k-1)) - min(plcl(i), ph(i,k))
-       cape(i) = cape(i) + rrd*buoy(i, k-1)*deltap/p(i, k-1)
-       IF (cape(i)>0.) THEN
-        inb(i) = max(inb(i), k)
-       END IF
-       ENDIF
-    ENDDO
-  ENDDO
-
-!  DO i = 1, ncum
-!     PRINT*,"inb",inb(i)
-!  ENDDO
-
-  ENDIF
-
-! -- end convect3
-
-! ori      do 510 i=1,ncum
-! ori        cape(i)=0.0
-! ori        capem(i)=0.0
-! ori        inb(i)=icb(i)+1
-! ori        inb1(i)=inb(i)
-! ori 510  continue
-
-! Originial Code
-
-!    do 530 k=minorig+1,nl-1
-!     do 520 i=1,ncum
-!      IF(k.ge.(icb(i)+1))THEN
-!       by=(tvp(i,k)-tv(i,k))*dph(i,k)/p(i,k)
-!       byp=(tvp(i,k+1)-tv(i,k+1))*dph(i,k+1)/p(i,k+1)
-!       cape(i)=cape(i)+by
-!       IF(by.ge.0.0)inb1(i)=k+1
-!       IF(cape(i).gt.0.0)THEN
-!        inb(i)=k+1
-!        capem(i)=cape(i)
-!       endif
-!      endif
-!520    continue
-!530  continue
-!    do 540 i=1,ncum
-!     byp=(tvp(i,nl)-tv(i,nl))*dph(i,nl)/p(i,nl)
-!     cape(i)=capem(i)+byp
-!     defrac=capem(i)-cape(i)
-!     defrac=max(defrac,0.001)
-!     frac(i)=-cape(i)/defrac
-!     frac(i)=min(frac(i),1.0)
-!     frac(i)=max(frac(i),0.0)
-!540   continue
-
-!    K Emanuel fix
-
-!    CALL zilch(byp,ncum)
-!    do 530 k=minorig+1,nl-1
-!     do 520 i=1,ncum
-!      IF(k.ge.(icb(i)+1))THEN
-!       by=(tvp(i,k)-tv(i,k))*dph(i,k)/p(i,k)
-!       cape(i)=cape(i)+by
-!       IF(by.ge.0.0)inb1(i)=k+1
-!       IF(cape(i).gt.0.0)THEN
-!        inb(i)=k+1
-!        capem(i)=cape(i)
-!        byp(i)=(tvp(i,k+1)-tv(i,k+1))*dph(i,k+1)/p(i,k+1)
-!       endif
-!      endif
-!520    continue
-!530  continue
-!    do 540 i=1,ncum
-!     inb(i)=max(inb(i),inb1(i))
-!     cape(i)=capem(i)+byp(i)
-!     defrac=capem(i)-cape(i)
-!     defrac=max(defrac,0.001)
-!     frac(i)=-cape(i)/defrac
-!     frac(i)=min(frac(i),1.0)
-!     frac(i)=max(frac(i),0.0)
-!540   continue
-
-! J Teixeira fix
-
-! ori      CALL zilch(byp,ncum)
-! ori      do 515 i=1,ncum
-! ori        lcape(i)=.TRUE.
-! ori 515  continue
-! ori      do 530 k=minorig+1,nl-1
-! ori        do 520 i=1,ncum
-! ori          IF(cape(i).lt.0.0)lcape(i)=.FALSE.
-! ori          if((k.ge.(icb(i)+1)).AND.lcape(i))THEN
-! ori            by=(tvp(i,k)-tv(i,k))*dph(i,k)/p(i,k)
-! ori            byp(i)=(tvp(i,k+1)-tv(i,k+1))*dph(i,k+1)/p(i,k+1)
-! ori            cape(i)=cape(i)+by
-! ori            IF(by.ge.0.0)inb1(i)=k+1
-! ori            IF(cape(i).gt.0.0)THEN
-! ori              inb(i)=k+1
-! ori              capem(i)=cape(i)
-! ori            endif
-! ori          endif
-! ori 520    continue
-! ori 530  continue
-! ori      do 540 i=1,ncum
-! ori          cape(i)=capem(i)+byp(i)
-! ori          defrac=capem(i)-cape(i)
-! ori          defrac=max(defrac,0.001)
-! ori          frac(i)=-cape(i)/defrac
-! ori          frac(i)=min(frac(i),1.0)
-! ori          frac(i)=max(frac(i),0.0)
-! ori 540  continue
-
-! --------------------------------------------------------------------
-!   Prevent convection when top is too hot
-! --------------------------------------------------------------------
-  DO i = 1,ncum
-    IF (t(i,inb(i)) > T_top_max) iflag(i) = 10
-  ENDDO
-
-! =====================================================================
-! ---   CALCULATE LIQUID WATER STATIC ENERGY OF LIFTED PARCEL
-! =====================================================================
+
+  ! =====================================================================
+  ! ---   CALCULATE LIQUID WATER STATIC ENERGY OF LIFTED PARCEL
+  ! =====================================================================
 
   DO k = 1, nl
@@ -1987,91 +1971,89 @@
   END DO
 
-!jyg : cvflag_ice test outside the loops (07042015)
+  !jyg : cvflag_ice test outside the loops (07042015)
 
   IF (cvflag_ice) THEN
 
-  IF (cvflag_prec_eject) THEN
-!!    DO k = minorig + 1, nl
-!!      DO i = 1, ncum
-!!        IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
-!!          frac_s(i,k) = qi(i,k)/max(clw(i,k),smallestreal)    
-!!          frac_s(i,k) = 1. - (qpl(i,k)+(1.-frac_s(i,k))*qcld(i,k))/max(clw(i,k),smallestreal)    
-!!        END IF
-!!      END DO
-!!    END DO
-  ELSE    ! (cvflag_prec_eject)
+    IF (cvflag_prec_eject) THEN
+      !!    DO k = minorig + 1, nl
+      !!      DO i = 1, ncum
+      !!        IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
+      !!          frac_s(i,k) = qi(i,k)/max(clw(i,k),smallestreal)
+      !!          frac_s(i,k) = 1. - (qpl(i,k)+(1.-frac_s(i,k))*qcld(i,k))/max(clw(i,k),smallestreal)
+      !!        END IF
+      !!      END DO
+      !!    END DO
+    ELSE    ! (cvflag_prec_eject)
+      DO k = minorig + 1, nl
+        DO i = 1, ncum
+          IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
+            !jyg< frac computation moved to beginning of cv3_undilute2.
+            !     kept here for compatibility test with CMip6 version
+            frac_s(i, k) = 1. - (t(i, k) - 243.15) / (263.15 - 243.15)
+            frac_s(i, k) = min(max(frac_s(i, k), 0.0), 1.0)
+          END IF
+        END DO
+      END DO
+    ENDIF  ! (cvflag_prec_eject) ELSE
     DO k = minorig + 1, nl
       DO i = 1, ncum
         IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
-!jyg< frac computation moved to beginning of cv3_undilute2.
-!     kept here for compatibility test with CMip6 version
-          frac_s(i, k) = 1. - (t(i,k)-243.15)/(263.15-243.15)
-          frac_s(i, k) = min(max(frac_s(i,k),0.0), 1.0)
+          !!          hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k)+frac_s(i,k)*lf(i,k))* &     !!jygprl
+          !!                              ep(i, k)*clw(i, k)                                    !!jygprl
+          hp(i, k) = hla(i, k - 1) + (lv(i, k) + (cpd - cpv) * t(i, k) + frac_s(i, k) * lf(i, k)) * &   !!jygprl
+                  ep(i, k) * clw(i, k)                                      !!jygprl
         END IF
       END DO
     END DO
-  ENDIF  ! (cvflag_prec_eject) ELSE
+
+  ELSE   ! (cvflag_ice)
+
     DO k = minorig + 1, nl
       DO i = 1, ncum
         IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
-!!          hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k)+frac_s(i,k)*lf(i,k))* &     !!jygprl
-!!                              ep(i, k)*clw(i, k)                                    !!jygprl
-          hp(i, k) = hla(i,k-1) + (lv(i,k)+(cpd-cpv)*t(i,k)+frac_s(i,k)*lf(i,k))* &   !!jygprl
-                              ep(i, k)*clw(i, k)                                      !!jygprl
+          !jyg<   (energy conservation tests)
+          !!          hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*tp(i,k))*ep(i, k)*clw(i, k)
+          !!          hp(i, k) = ( hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k))*ep(i, k)*clw(i, k) ) / &
+          !!                     (1. - ep(i,k)*clw(i,k))
+          !!          hp(i, k) = ( hnk(i) + (lv(i,k)+(cpd-cl)*t(i,k))*ep(i, k)*clw(i, k) ) / &
+          !!                     (1. - ep(i,k)*clw(i,k))
+          hp(i, k) = hnk(i) + (lv(i, k) + (cpd - cpv) * t(i, k)) * ep(i, k) * clw(i, k)
         END IF
       END DO
     END DO
 
-  ELSE   ! (cvflag_ice)
-
-    DO k = minorig + 1, nl
-      DO i = 1, ncum
-        IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
-!jyg<   (energy conservation tests)
-!!          hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*tp(i,k))*ep(i, k)*clw(i, k)
-!!          hp(i, k) = ( hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k))*ep(i, k)*clw(i, k) ) / &
-!!                     (1. - ep(i,k)*clw(i,k))
-!!          hp(i, k) = ( hnk(i) + (lv(i,k)+(cpd-cl)*t(i,k))*ep(i, k)*clw(i, k) ) / &
-!!                     (1. - ep(i,k)*clw(i,k))
-          hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k))*ep(i, k)*clw(i, k)
-        END IF
-      END DO
-    END DO
-
   END IF  ! (cvflag_ice)
 
-
 END SUBROUTINE cv3_undilute2
 
-SUBROUTINE cv3_closure(nloc, ncum, nd, icb, inb, &
-                       pbase, p, ph, tv, buoy, &
-                       sig, w0, cape, m, iflag)
+SUBROUTINE cv3_closure(nloc, ncum, nd, icb, inb, pbase, p, ph, tv, buoy, &
+        sig, w0, cape, m, iflag)
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
-! ===================================================================
-! ---  CLOSURE OF CONVECT3
-
-! vectorization: S. Bony
-! ===================================================================
-
-  include "cvthermo.h"
-  include "cv3param.h"
-
-!input:
+  ! ===================================================================
+  ! ---  CLOSURE OF CONVECT3
+
+  ! vectorization: S. Bony
+  ! ===================================================================
+
+  !input:
   INTEGER ncum, nd, nloc
   INTEGER icb(nloc), inb(nloc)
   REAL pbase(nloc)
-  REAL p(nloc, nd), ph(nloc, nd+1)
+  REAL p(nloc, nd), ph(nloc, nd + 1)
   REAL tv(nloc, nd), buoy(nloc, nd)
 
-!input/output:
+  !input/output:
   REAL sig(nloc, nd), w0(nloc, nd)
   INTEGER iflag(nloc)
 
-!output:
+  !output:
   REAL cape(nloc)
   REAL m(nloc, nd)
 
-!local variables:
+  !local variables:
   INTEGER i, j, k, icbmax
   REAL deltap, fac, w, amu
@@ -2080,7 +2062,7 @@
 
 
-! -------------------------------------------------------
-! -- Initialization
-! -------------------------------------------------------
+  ! -------------------------------------------------------
+  ! -- Initialization
+  ! -------------------------------------------------------
 
   DO k = 1, nl
@@ -2090,22 +2072,22 @@
   END DO
 
-! -------------------------------------------------------
-! -- Reset sig(i) and w0(i) for i>inb and i<icb
-! -------------------------------------------------------
-
-! update sig and w0 above LNB:
+  ! -------------------------------------------------------
+  ! -- Reset sig(i) and w0(i) for i>inb and i<icb
+  ! -------------------------------------------------------
+
+  ! update sig and w0 above LNB:
 
   DO k = 1, nl - 1
     DO i = 1, ncum
-      IF ((inb(i)<(nl-1)) .AND. (k>=(inb(i)+1))) THEN
-        sig(i, k) = beta*sig(i, k) + &
-                    2.*alpha*buoy(i, inb(i))*abs(buoy(i,inb(i)))
-        sig(i, k) = amax1(sig(i,k), 0.0)
-        w0(i, k) = beta*w0(i, k)
+      IF ((inb(i)<(nl - 1)) .AND. (k>=(inb(i) + 1))) THEN
+        sig(i, k) = beta * sig(i, k) + &
+                2. * alpha * buoy(i, inb(i)) * abs(buoy(i, inb(i)))
+        sig(i, k) = amax1(sig(i, k), 0.0)
+        w0(i, k) = beta * w0(i, k)
       END IF
     END DO
   END DO
 
-! compute icbmax:
+  ! compute icbmax:
 
   icbmax = 2
@@ -2114,40 +2096,40 @@
   END DO
 
-! update sig and w0 below cloud base:
+  ! update sig and w0 below cloud base:
 
   DO k = 1, icbmax
     DO i = 1, ncum
       IF (k<=icb(i)) THEN
-        sig(i, k) = beta*sig(i, k) - &
-                    2.*alpha*buoy(i, icb(i))*buoy(i, icb(i))
-        sig(i, k) = max(sig(i,k), 0.0)
-        w0(i, k) = beta*w0(i, k)
+        sig(i, k) = beta * sig(i, k) - &
+                2. * alpha * buoy(i, icb(i)) * buoy(i, icb(i))
+        sig(i, k) = max(sig(i, k), 0.0)
+        w0(i, k) = beta * w0(i, k)
       END IF
     END DO
   END DO
 
-!!      IF(inb.lt.(nl-1))THEN
-!!         do 85 i=inb+1,nl-1
-!!            sig(i)=beta*sig(i)+2.*alpha*buoy(inb)*
-!!     1              abs(buoy(inb))
-!!            sig(i)=max(sig(i),0.0)
-!!            w0(i)=beta*w0(i)
-!!   85    continue
-!!      end if
-
-!!      do 87 i=1,icb
-!!         sig(i)=beta*sig(i)-2.*alpha*buoy(icb)*buoy(icb)
-!!         sig(i)=max(sig(i),0.0)
-!!         w0(i)=beta*w0(i)
-!!   87 continue
-
-! -------------------------------------------------------------
-! -- Reset fractional areas of updrafts and w0 at initial time
-! -- and after 10 time steps of no convection
-! -------------------------------------------------------------
+  !!      IF(inb.lt.(nl-1))THEN
+  !!         do 85 i=inb+1,nl-1
+  !!            sig(i)=beta*sig(i)+2.*alpha*buoy(inb)*
+  !!     1              abs(buoy(inb))
+  !!            sig(i)=max(sig(i),0.0)
+  !!            w0(i)=beta*w0(i)
+  !!   85    continue
+  !!      end if
+
+  !!      do 87 i=1,icb
+  !!         sig(i)=beta*sig(i)-2.*alpha*buoy(icb)*buoy(icb)
+  !!         sig(i)=max(sig(i),0.0)
+  !!         w0(i)=beta*w0(i)
+  !!   87 continue
+
+  ! -------------------------------------------------------------
+  ! -- Reset fractional areas of updrafts and w0 at initial time
+  ! -- and after 10 time steps of no convection
+  ! -------------------------------------------------------------
 
   DO k = 1, nl - 1
     DO i = 1, ncum
-      IF (sig(i,nd)<1.5 .OR. sig(i,nd)>12.0) THEN
+      IF (sig(i, nd)<1.5 .OR. sig(i, nd)>12.0) THEN
         sig(i, k) = 0.0
         w0(i, k) = 0.0
@@ -2156,9 +2138,9 @@
   END DO
 
-! -------------------------------------------------------------
-! -- Calculate convective available potential energy (cape),
-! -- vertical velocity (w), fractional area covered by
-! -- undilute updraft (sig), and updraft mass flux (m)
-! -------------------------------------------------------------
+  ! -------------------------------------------------------------
+  ! -- Calculate convective available potential energy (cape),
+  ! -- vertical velocity (w), fractional area covered by
+  ! -- undilute updraft (sig), and updraft mass flux (m)
+  ! -------------------------------------------------------------
 
   DO i = 1, ncum
@@ -2166,5 +2148,5 @@
   END DO
 
-! compute dtmin (minimum buoyancy between ICB and given level k):
+  ! compute dtmin (minimum buoyancy between ICB and given level k):
 
   DO i = 1, ncum
@@ -2177,6 +2159,6 @@
     DO k = 1, nl
       DO j = minorig, nl
-        IF ((k>=(icb(i)+1)) .AND. (k<=inb(i)) .AND. (j>=icb(i)) .AND. (j<=(k-1))) THEN
-          dtmin(i, k) = amin1(dtmin(i,k), buoy(i,j))
+        IF ((k>=(icb(i) + 1)) .AND. (k<=inb(i)) .AND. (j>=icb(i)) .AND. (j<=(k - 1))) THEN
+          dtmin(i, k) = amin1(dtmin(i, k), buoy(i, j))
         END IF
       END DO
@@ -2184,28 +2166,28 @@
   END DO
 
-! the interval on which cape is computed starts at pbase :
+  ! the interval on which cape is computed starts at pbase :
 
   DO k = 1, nl
     DO i = 1, ncum
 
-      IF ((k>=(icb(i)+1)) .AND. (k<=inb(i))) THEN
-
-        deltap = min(pbase(i), ph(i,k-1)) - min(pbase(i), ph(i,k))
-        cape(i) = cape(i) + rrd*buoy(i, k-1)*deltap/p(i, k-1)
+      IF ((k>=(icb(i) + 1)) .AND. (k<=inb(i))) THEN
+
+        deltap = min(pbase(i), ph(i, k - 1)) - min(pbase(i), ph(i, k))
+        cape(i) = cape(i) + rrd * buoy(i, k - 1) * deltap / p(i, k - 1)
         cape(i) = amax1(0.0, cape(i))
         sigold(i, k) = sig(i, k)
 
-! dtmin(i,k)=100.0
-! do 97 j=icb(i),k-1 ! mauvaise vectorisation
-! dtmin(i,k)=AMIN1(dtmin(i,k),buoy(i,j))
-! 97     continue
-
-        sig(i, k) = beta*sig(i, k) + alpha*dtmin(i, k)*abs(dtmin(i,k))
-        sig(i, k) = max(sig(i,k), 0.0)
-        sig(i, k) = amin1(sig(i,k), 0.01)
-        fac = amin1(((dtcrit-dtmin(i,k))/dtcrit), 1.0)
-        w = (1.-beta)*fac*sqrt(cape(i)) + beta*w0(i, k)
-        amu = 0.5*(sig(i,k)+sigold(i,k))*w
-        m(i, k) = amu*0.007*p(i, k)*(ph(i,k)-ph(i,k+1))/tv(i, k)
+        ! dtmin(i,k)=100.0
+        ! do 97 j=icb(i),k-1 ! mauvaise vectorisation
+        ! dtmin(i,k)=AMIN1(dtmin(i,k),buoy(i,j))
+        ! 97     continue
+
+        sig(i, k) = beta * sig(i, k) + alpha * dtmin(i, k) * abs(dtmin(i, k))
+        sig(i, k) = max(sig(i, k), 0.0)
+        sig(i, k) = amin1(sig(i, k), 0.01)
+        fac = amin1(((dtcrit - dtmin(i, k)) / dtcrit), 1.0)
+        w = (1. - beta) * fac * sqrt(cape(i)) + beta * w0(i, k)
+        amu = 0.5 * (sig(i, k) + sigold(i, k)) * w
+        m(i, k) = amu * 0.007 * p(i, k) * (ph(i, k) - ph(i, k + 1)) / tv(i, k)
         w0(i, k) = w
       END IF
@@ -2215,113 +2197,111 @@
 
   DO i = 1, ncum
-    w0(i, icb(i)) = 0.5*w0(i, icb(i)+1)
-    m(i, icb(i)) = 0.5*m(i, icb(i)+1)*(ph(i,icb(i))-ph(i,icb(i)+1))/(ph(i,icb(i)+1)-ph(i,icb(i)+2))
-    sig(i, icb(i)) = sig(i, icb(i)+1)
-    sig(i, icb(i)-1) = sig(i, icb(i))
-  END DO
-
-! ccc 3. Compute final cloud base mass flux and set iflag to 3 if
-! ccc    cloud base mass flux is exceedingly small and is decreasing (i.e. if
-! ccc    the final mass flux (cbmflast) is greater than the target mass flux
-! ccc    (cbmf) ??).
-! cc
-! c      do i = 1,ncum
-! c       cbmflast(i) = 0.
-! c      enddo
-! cc
-! c      do k= 1,nl
-! c       do i = 1,ncum
-! c        IF (k .ge. icb(i) .AND. k .le. inb(i)) THEN
-! c         cbmflast(i) = cbmflast(i)+M(i,k)
-! c        ENDIF
-! c       enddo
-! c      enddo
-! cc
-! c      do i = 1,ncum
-! c       IF (cbmflast(i) .lt. 1.e-6) THEN
-! c         iflag(i) = 3
-! c       ENDIF
-! c      enddo
-! cc
-! c      do k= 1,nl
-! c       do i = 1,ncum
-! c        IF (iflag(i) .ge. 3) THEN
-! c         M(i,k) = 0.
-! c         sig(i,k) = 0.
-! c         w0(i,k) = 0.
-! c        ENDIF
-! c       enddo
-! c      enddo
-! cc
-!!      cape=0.0
-!!      do 98 i=icb+1,inb
-!!         deltap = min(pbase,ph(i-1))-min(pbase,ph(i))
-!!         cape=cape+rrd*buoy(i-1)*deltap/p(i-1)
-!!         dcape=rrd*buoy(i-1)*deltap/p(i-1)
-!!         dlnp=deltap/p(i-1)
-!!         cape=max(0.0,cape)
-!!         sigold=sig(i)
-
-!!         dtmin=100.0
-!!         do 97 j=icb,i-1
-!!            dtmin=amin1(dtmin,buoy(j))
-!!   97    continue
-
-!!         sig(i)=beta*sig(i)+alpha*dtmin*abs(dtmin)
-!!         sig(i)=max(sig(i),0.0)
-!!         sig(i)=amin1(sig(i),0.01)
-!!         fac=amin1(((dtcrit-dtmin)/dtcrit),1.0)
-!!         w=(1.-beta)*fac*sqrt(cape)+beta*w0(i)
-!!         amu=0.5*(sig(i)+sigold)*w
-!!         m(i)=amu*0.007*p(i)*(ph(i)-ph(i+1))/tv(i)
-!!         w0(i)=w
-!!   98 continue
-!!      w0(icb)=0.5*w0(icb+1)
-!!      m(icb)=0.5*m(icb+1)*(ph(icb)-ph(icb+1))/(ph(icb+1)-ph(icb+2))
-!!      sig(icb)=sig(icb+1)
-!!      sig(icb-1)=sig(icb)
-
+    w0(i, icb(i)) = 0.5 * w0(i, icb(i) + 1)
+    m(i, icb(i)) = 0.5 * m(i, icb(i) + 1) * (ph(i, icb(i)) - ph(i, icb(i) + 1)) / (ph(i, icb(i) + 1) - ph(i, icb(i) + 2))
+    sig(i, icb(i)) = sig(i, icb(i) + 1)
+    sig(i, icb(i) - 1) = sig(i, icb(i))
+  END DO
+
+  ! ccc 3. Compute final cloud base mass flux and set iflag to 3 if
+  ! ccc    cloud base mass flux is exceedingly small and is decreasing (i.e. if
+  ! ccc    the final mass flux (cbmflast) is greater than the target mass flux
+  ! ccc    (cbmf) ??).
+  ! cc
+  ! c      do i = 1,ncum
+  ! c       cbmflast(i) = 0.
+  ! c      enddo
+  ! cc
+  ! c      do k= 1,nl
+  ! c       do i = 1,ncum
+  ! c        IF (k .ge. icb(i) .AND. k .le. inb(i)) THEN
+  ! c         cbmflast(i) = cbmflast(i)+M(i,k)
+  ! c        ENDIF
+  ! c       enddo
+  ! c      enddo
+  ! cc
+  ! c      do i = 1,ncum
+  ! c       IF (cbmflast(i) .lt. 1.e-6) THEN
+  ! c         iflag(i) = 3
+  ! c       ENDIF
+  ! c      enddo
+  ! cc
+  ! c      do k= 1,nl
+  ! c       do i = 1,ncum
+  ! c        IF (iflag(i) .ge. 3) THEN
+  ! c         M(i,k) = 0.
+  ! c         sig(i,k) = 0.
+  ! c         w0(i,k) = 0.
+  ! c        ENDIF
+  ! c       enddo
+  ! c      enddo
+  ! cc
+  !!      cape=0.0
+  !!      do 98 i=icb+1,inb
+  !!         deltap = min(pbase,ph(i-1))-min(pbase,ph(i))
+  !!         cape=cape+rrd*buoy(i-1)*deltap/p(i-1)
+  !!         dcape=rrd*buoy(i-1)*deltap/p(i-1)
+  !!         dlnp=deltap/p(i-1)
+  !!         cape=max(0.0,cape)
+  !!         sigold=sig(i)
+
+  !!         dtmin=100.0
+  !!         do 97 j=icb,i-1
+  !!            dtmin=amin1(dtmin,buoy(j))
+  !!   97    continue
+
+  !!         sig(i)=beta*sig(i)+alpha*dtmin*abs(dtmin)
+  !!         sig(i)=max(sig(i),0.0)
+  !!         sig(i)=amin1(sig(i),0.01)
+  !!         fac=amin1(((dtcrit-dtmin)/dtcrit),1.0)
+  !!         w=(1.-beta)*fac*sqrt(cape)+beta*w0(i)
+  !!         amu=0.5*(sig(i)+sigold)*w
+  !!         m(i)=amu*0.007*p(i)*(ph(i)-ph(i+1))/tv(i)
+  !!         w0(i)=w
+  !!   98 continue
+  !!      w0(icb)=0.5*w0(icb+1)
+  !!      m(icb)=0.5*m(icb+1)*(ph(icb)-ph(icb+1))/(ph(icb+1)-ph(icb+2))
+  !!      sig(icb)=sig(icb+1)
+  !!      sig(icb-1)=sig(icb)
 
 END SUBROUTINE cv3_closure
 
 SUBROUTINE cv3_mixing(nloc, ncum, nd, na, ntra, icb, nk, inb, &
-                      ph, t, rr, rs, u, v, tra, h, lv, lf, frac, qnk, &
-                      unk, vnk, hp, tv, tvp, ep, clw, m, sig, &
-                      ment, qent, uent, vent, nent, sij, elij, ments, qents, traent)
+        ph, t, rr, rs, u, v, tra, h, lv, lf, frac, qnk, &
+        unk, vnk, hp, tv, tvp, ep, clw, m, sig, &
+        ment, qent, uent, vent, nent, sij, elij, ments, qents, traent)
   USE lmdz_cvflag
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
 
   IMPLICIT NONE
 
-! ---------------------------------------------------------------------
-! a faire:
-! - vectorisation de la partie normalisation des flux (do 789...)
-! ---------------------------------------------------------------------
-
-  include "cvthermo.h"
-  include "cv3param.h"
-
-!inputs:
-  INTEGER, INTENT (IN)                               :: ncum, nd, na, ntra, nloc
-  INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, inb, nk
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: sig
-  REAL, DIMENSION (nloc), INTENT (IN)                :: qnk, unk, vnk
-  REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: ph
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, rr, rs
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: u, v
-  REAL, DIMENSION (nloc, nd, ntra), INTENT (IN)      :: tra               ! input of convect3
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: lv, h, hp
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: lf, frac
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: tv, tvp, ep, clw
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: m                 ! input of convect3
-
-!outputs:
-  REAL, DIMENSION (nloc, na, na), INTENT (OUT)        :: ment, qent
-  REAL, DIMENSION (nloc, na, na), INTENT (OUT)        :: uent, vent
-  REAL, DIMENSION (nloc, na, na), INTENT (OUT)        :: sij, elij
-  REAL, DIMENSION (nloc, nd, nd, ntra), INTENT (OUT)  :: traent
-  REAL, DIMENSION (nloc, nd, nd), INTENT (OUT)        :: ments, qents
-  INTEGER, DIMENSION (nloc, nd), INTENT (OUT)         :: nent
-
-!local variables:
+  ! ---------------------------------------------------------------------
+  ! a faire:
+  ! - vectorisation de la partie normalisation des flux (do 789...)
+  ! ---------------------------------------------------------------------
+
+  !inputs:
+  INTEGER, INTENT (IN) :: ncum, nd, na, ntra, nloc
+  INTEGER, DIMENSION (nloc), INTENT (IN) :: icb, inb, nk
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: sig
+  REAL, DIMENSION (nloc), INTENT (IN) :: qnk, unk, vnk
+  REAL, DIMENSION (nloc, nd + 1), INTENT (IN) :: ph
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: t, rr, rs
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: u, v
+  REAL, DIMENSION (nloc, nd, ntra), INTENT (IN) :: tra               ! input of convect3
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: lv, h, hp
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: lf, frac
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: tv, tvp, ep, clw
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: m                 ! input of convect3
+
+  !outputs:
+  REAL, DIMENSION (nloc, na, na), INTENT (OUT) :: ment, qent
+  REAL, DIMENSION (nloc, na, na), INTENT (OUT) :: uent, vent
+  REAL, DIMENSION (nloc, na, na), INTENT (OUT) :: sij, elij
+  REAL, DIMENSION (nloc, nd, nd, ntra), INTENT (OUT) :: traent
+  REAL, DIMENSION (nloc, nd, nd), INTENT (OUT) :: ments, qents
+  INTEGER, DIMENSION (nloc, nd), INTENT (OUT) :: nent
+
+  !local variables:
   INTEGER i, j, k, il, im, jm
   INTEGER num1, num2
@@ -2335,19 +2315,19 @@
   LOGICAL lwork(nloc)
 
-! =====================================================================
-! --- INITIALIZE VARIOUS ARRAYS USED IN THE COMPUTATIONS
-! =====================================================================
-
-! ori        do 360 i=1,ncum*nlp
+  ! =====================================================================
+  ! --- INITIALIZE VARIOUS ARRAYS USED IN THE COMPUTATIONS
+  ! =====================================================================
+
+  ! ori        do 360 i=1,ncum*nlp
   DO j = 1, nl
     DO i = 1, ncum
       nent(i, j) = 0
-! in convect3, m is computed in cv3_closure
-! ori          m(i,1)=0.0
-    END DO
-  END DO
-
-! ori      do 400 k=1,nlp
-! ori       do 390 j=1,nlp
+      ! in convect3, m is computed in cv3_closure
+      ! ori          m(i,1)=0.0
+    END DO
+  END DO
+
+  ! ori      do 400 k=1,nlp
+  ! ori       do 390 j=1,nlp
   DO j = 1, nl
     DO k = 1, nl
@@ -2357,30 +2337,30 @@
         vent(i, k, j) = v(i, j)
         elij(i, k, j) = 0.0
-!ym            ment(i,k,j)=0.0
-!ym            sij(i,k,j)=0.0
+        !ym            ment(i,k,j)=0.0
+        !ym            sij(i,k,j)=0.0
       END DO
     END DO
   END DO
 
-!ym
+  !ym
   ment(1:ncum, 1:nd, 1:nd) = 0.0
   sij(1:ncum, 1:nd, 1:nd) = 0.0
 
-!AC!      do k=1,ntra
-!AC!       do j=1,nd  ! instead nlp
-!AC!        do i=1,nd ! instead nlp
-!AC!         do il=1,ncum
-!AC!            traent(il,i,j,k)=tra(il,j,k)
-!AC!         enddo
-!AC!        enddo
-!AC!       enddo
-!AC!      enddo
+  !AC!      do k=1,ntra
+  !AC!       do j=1,nd  ! instead nlp
+  !AC!        do i=1,nd ! instead nlp
+  !AC!         do il=1,ncum
+  !AC!            traent(il,i,j,k)=tra(il,j,k)
+  !AC!         enddo
+  !AC!        enddo
+  !AC!       enddo
+  !AC!      enddo
   zm(:, :) = 0.
 
-! =====================================================================
-! --- CALCULATE ENTRAINED AIR MASS FLUX (ment), TOTAL WATER MIXING
-! --- RATIO (QENT), TOTAL CONDENSED WATER (elij), AND MIXING
-! --- FRACTION (sij)
-! =====================================================================
+  ! =====================================================================
+  ! --- CALCULATE ENTRAINED AIR MASS FLUX (ment), TOTAL WATER MIXING
+  ! --- RATIO (QENT), TOTAL CONDENSED WATER (elij), AND MIXING
+  ! --- FRACTION (sij)
+  ! =====================================================================
 
   DO i = minorig + 1, nl
